com.lowagie.text.pdf.codec

## Class TIFFFaxDecoder

- java.lang.Object
- - com.lowagie.text.pdf.codec.TIFFFaxDecoder

-     public class TIFFFaxDecoder
      extends java.lang.Object

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `(package private) static short[]` | `additionalMakeup`
    `private int` | `bitPointer`
    `(package private) static short[]` | `black`
    `private int` | `bytePointer`
    `private int` | `changingElemSize`
    `private int` | `compression`
    `private int[]` | `currChangingElems`
    `private byte[]` | `data`
    `private int` | `fillBits`
    `private int` | `fillOrder`
    `(package private) static byte[]` | `flipTable`
    `private int` | `h`
    `(package private) static short[]` | `initBlack`
    `private int` | `lastChangingElement`
    `private int` | `oneD`
    `private int[]` | `prevChangingElems`
    `(package private) static int[]` | `table1`
    `(package private) static int[]` | `table2`
    `(package private) static short[]` | `twoBitBlack`
    `(package private) static byte[]` | `twoDCodes`
    `private int` | `uncompressedMode`
    `private int` | `w`
    `(package private) static short[]` | `white`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TIFFFaxDecoder(int fillOrder, int w, int h)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `private boolean` | `advancePointer()`
    `void` | `decode1D(byte[] buffer, byte[] compData, int startX, int height)`
    `void` | `decode2D(byte[] buffer, byte[] compData, int startX, int height, long tiffT4Options)`
    `private int` | `decodeBlackCodeWord()`
    `void` | `decodeNextScanline(byte[] buffer, int lineOffset, int bitOffset)`
    `void` | `decodeT6(byte[] buffer, byte[] compData, int startX, int height, long tiffT6Options)`
    `private int` | `decodeWhiteCodeWord()`
    `private void` | `getNextChangingElement(int a0, boolean isWhite, int[] ret)`
    `private int` | `nextLesserThan8Bits(int bitsToGet)`
    `private int` | `nextNBits(int bitsToGet)`
    `private int` | `readEOL(boolean isFirstEOL)`
    `static void` | `reverseBits(byte[] b)` Reverses the bits in the array
    `private void` | `setToBlack(byte[] buffer, int lineOffset, int bitOffset, int numBits)`
    `private void` | `updatePointer(int bitsToMoveBack)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### bitPointer

          private int bitPointer

    - #### bytePointer

          private int bytePointer

    - #### data

          private byte[] data

    - #### w

          private int w

    - #### h

          private int h

    - #### fillOrder

          private int fillOrder

    - #### changingElemSize

          private int changingElemSize

    - #### prevChangingElems

          private int[] prevChangingElems

    - #### currChangingElems

          private int[] currChangingElems

    - #### lastChangingElement

          private int lastChangingElement

    - #### compression

          private int compression

    - #### uncompressedMode

          private int uncompressedMode

    - #### fillBits

          private int fillBits

    - #### oneD

          private int oneD

    - #### table1

          static int[] table1

    - #### table2

          static int[] table2

    - #### flipTable

          static byte[] flipTable

    - #### white

          static short[] white

    - #### additionalMakeup

          static short[] additionalMakeup

    - #### initBlack

          static short[] initBlack

    - #### twoBitBlack

          static short[] twoBitBlack

    - #### black

          static short[] black

    - #### twoDCodes

          static byte[] twoDCodes

  - ### Constructor Detail

    - #### TIFFFaxDecoder

          public TIFFFaxDecoder(int fillOrder,
                        int w,
                        int h)

      Parameters:
        `fillOrder` - The fill order of the compressed data bytes.
        `w` -
        `h` -

  - ### Method Detail

    - #### reverseBits

          public static void reverseBits(byte[] b)

      Reverses the bits in the array
      Parameters:
        `b` - the bits to reverse
      Since:
        2.0.7

    - #### decode1D

          public void decode1D(byte[] buffer,
                      byte[] compData,
                      int startX,
                      int height)

    - #### decodeNextScanline

          public void decodeNextScanline(byte[] buffer,
                                int lineOffset,
                                int bitOffset)

    - #### decode2D

          public void decode2D(byte[] buffer,
                      byte[] compData,
                      int startX,
                      int height,
                      long tiffT4Options)

    - #### decodeT6

          public void decodeT6(byte[] buffer,
                      byte[] compData,
                      int startX,
                      int height,
                      long tiffT6Options)

    - #### setToBlack

          private void setToBlack(byte[] buffer,
                        int lineOffset,
                        int bitOffset,
                        int numBits)

    - #### decodeWhiteCodeWord

          private int decodeWhiteCodeWord()

    - #### decodeBlackCodeWord

          private int decodeBlackCodeWord()

    - #### readEOL

          private int readEOL(boolean isFirstEOL)

    - #### getNextChangingElement

          private void getNextChangingElement(int a0,
                                    boolean isWhite,
                                    int[] ret)

    - #### nextNBits

          private int nextNBits(int bitsToGet)

    - #### nextLesserThan8Bits

          private int nextLesserThan8Bits(int bitsToGet)

    - #### updatePointer

          private void updatePointer(int bitsToMoveBack)

    - #### advancePointer

          private boolean advancePointer()